import utils, reader, config, section
import math, sys, string

def load_dataset():
    utils.p( "* Reading corpus..." )
    try:
        utils.p("* Loading from pickle...")
        return utils.load_section()
    except:
        utils.p("* Loading from XML...")
        s = reader.read_corpus()

        return s

def get_title_by_tfidf( sec, root_sec ):
    np_to_tfidf = {}
    
    for np in sec.get_body_nps():
        np_to_tfidf[ np ] = sec.get_np_count( np ) * math.log( 1.0 / root_sec.get_corpus_np_count( np ) )

    nps_tfidf_ranked = utils.sort_dict_by_values( np_to_tfidf )
    
    if len( nps_tfidf_ranked ) > 0:
        return str( ' '.join( sec.capitalize_title( [ section.Word(x) for x in nps_tfidf_ranked[0].split(None) ]  ) ) )
    else:
        return ""
    
def main():
    config.DATASET_NAME = sys.argv[1]

    utils.p("* Loading from XML...")
    root_section = load_dataset()
    all_sections = root_section.get_descendants()
    for sec_num, sec in enumerate(all_sections):
        #for i in range( sec.get_depth() ): print "  ",
        #print  str(sec_num) + ": " + get_title_by_tfidf( sec, root_section )
        #for i in range( sec.get_depth() ): print "  ",
        #print sec.title.text

        print "FLT: " + get_title_by_tfidf( sec, root_section )
        print "ACT: " + sec.title.text
        print 
        #print
    
if __name__ == '__main__':
    sys.exit( main( ) )

