class StemModel:

    def __init__( self, root_section ):
        self.__stempos_to_word = {}
        
        for sec in root_section.get_descendants():
            for word in sec.unique_word_objs:
                if not self.__stempos_to_word.has_key( word.stem ):
                    self.__stempos_to_word[ word.stem ] = set()
                self.__stempos_to_word[ word.stem ].add( word )

    def get_words_by_stem( self, stem ):
        return self.__stempos_to_word.get( stem, set() )

    def get_words_by_section( self, sec ):
        for sec_word in sec.unique_word_objs:
            for word in self.get_words_by_stem( sec_word.stem ):
                yield word
